<?php
/*
 * Created on 09 Mars 2009
 *
 * Une petite classe string pour la nostalgie elle sert  rien mais a m'amuse
 * 
 * J'ai pomp le nom des methodes de la classe java String 
 * http://www.siteduzero.com/tutoriel-3-10328-les-methodes-de-classe.html
/******************************************************************************/
class string 
{
	var $chaine;

/*
 * Constructor
 */	
	function string($chaine='') 
	{
		$this->chaine=$chaine;
	}
	
	
/*
 * Fonctions diverses et avaries
 */
	function extraire_chaine_entre($chaine_deb,$chaine_fin) 
	{
		$extr='';
		$debut = strpos($this->chaine,$chaine_deb);
		$fin = strrpos($this->chaine,$chaine_fin);
		$extr = substr($this->chaine,$debut+strlen($chaine_deb),$fin-($debut+strlen($chaine_deb)));
		return new string($extr);
	}

	/*
	 * Mise en minuscule
	 */
	function toLowerCase() 
	{
		return new string(strtolower($this->chaine));
	}
	
	/*
	 * Mise en majuscule 
	 */
	function toUpperCase() 
	{
		return new string(strtoupper($this->chaine));
	}
	
	/*
	 * Concatner la chaine de l'instance avec une autre chaine 
	 */	
	function concat($variable)
	{
		if (is_a($variable,'string'))
			return new string($this->chaine.$variable->get_chaine());			
		elseif (is_string($variable))
			return new string($this->chaine.$variable);
		else
			return 	new string($this->chaine);	
		
	}
	
/*
 * Longueur de la chane
 */	
	function length()
	{
		return strlen($this->chaine);
	}

/*
 * Vrifie si les deux chaines sont identiques
 */	
	function equals($variable)
	{
		if (is_a($variable,'string'))
			return ($this->chaine == $variable->get_chaine());
		elseif(is_string($variable))
			return ($this->chaine == $variable);
		else
			return 	false;	
	}
	
	/*
	 * renvoi le caractre de la position 0 est le premier caractre
	 */
	function charAt($pos)
	{
		if ($pos>=0 && $pos<=$this->length()-1)
			return substr($this->chaine,$pos,1);
		else
			return false;
	}

	/*
	 * Comme son nom l'indique, elle permet d'extraire une sous-chane de 
	 * caractres d'une chane de caractres. 
	 * Cette mthode prend 2 entiers comme arguments. 
	 * Le premier dfinit le dbut de la sous-chane  extraire inclus, 
	 * le deuxime correspond au dernier caractre  extraire exclus. 
	 * Et le premier caractre est aussi le numro 0.
	 */
	function substring($deb,$fin)
	{
		if (($deb>=0 && $deb<=($this->length()-1)) && ($deb<$fin) && ($fin<=($this->length())))
		{
			return new string(substr($this->chaine,$deb,($fin-$deb)));
		}
		else
			return false;
	}
	
	/*
	 * Retourne la position dans la chaine de la chane pass en paramtre
	 */
	function indexOf($chaine)
	{
		return (!(strpos($this->chaine,$chaine) === false))?(strpos($this->chaine,$chaine)):-1;
	}

	/*
	 * Retourne la dernire position dans la chaine de la chane pass en paramtre
	 */
	function lastIndexOf($chaine)
	{
		//Test de la valeur false pour viter de renvoyer -1 si le caractre est en 1 place
		return ((strrpos($this->chaine,$chaine) === false))?-1:(strrpos($this->chaine,$chaine));
	}
	
	/*
	 * Suppression d'une sous string dans la chaine accepte les string ou les objets 'string'
	 */
	function supprime($substr)
	{
		if (is_a($substr,'string'))
		{
			$substr = $substr->get_chaine();			
		}
		$long = strlen($substr);
		$tmp = new string($this->chaine);

		while ($tmp->indexOf($substr) != -1)
		{
			if ($tmp->indexOf($substr)!=0)
				$tmp = $tmp->substring(0,$tmp->indexOf($substr))->concat($tmp->substring($tmp->indexOf($substr)+$long,$tmp->length()));
			else
				$tmp = $tmp->substring($tmp->indexOf($substr)+$long,$tmp->length());
		}
		return $tmp;	
	}
	
	/*
	 * Remplace un motif par un autre
	 */
	function remplace ($chaine_remplace,$chaine_remplacante)
	{
		if (is_a($chaine_remplace,'string'))
			$chaine_remplace = $chaine_remplace->get_chaine();
		if (is_a($chaine_remplacante,'string'))
			$chaine_remplacante = $chaine_remplacante->get_chaine();
		return new string(str_ireplace($chaine_remplace,$chaine_remplacante,$this->chaine));
	}
	
/*
 * Getteur
 */
	function get_chaine()
	{
		return $this->chaine;
	}
	
	
	/*
	 * Renvoi la chaine sous forme de tableau
	 */
	function get_tab()
	{
		return str_split($this->chaine);	
	}
	
}
?>